/********************************************************************************/
/*!
	@file			term_io.h
	@author         Nemui Trinomius (http://nemuisan.blog.bai.ne.jp)
    @version        3.00
    @date           2011.03.10
	@brief          Interface of Chan's Universal string handler For STM32 uC. @n
					Based on Chan's FatFs Test Terminal Thanks!

    @section HISTORY
		2010.06.01	V1.00	Start Here.
		2010.08.28	V1.10	Add Etherpod+TFT-LCD Shield's Key.
		2010.12.31	V2.00	Removed uart includion.
		2011.03.10	V3.00	C++ Ready.

    @section LICENSE
		BSD License. See Copyright.txt
*/
/********************************************************************************/
#ifndef __TERM_IO_H
#define __TERM_IO_H	0x0300

#ifdef __cplusplus
 extern "C" {
#endif

/* Basics */
#include <stdarg.h>
#include <string.h>
#include "monitor.h"

/* Miscs */
#include "hw_config.h"

#define __kbhit() keypressed()

/* Externals */
extern unsigned char xgetc (void);



#ifdef __cplusplus
}
#endif

#endif	/* __TERM_IO_H */
